﻿DECLARE
	@@PROC_ID VARCHAR(12),
	@@PROCESS_ID BIGINT,
	@@LAST_PROCESS_ID VARCHAR(12),
	@@TODAY VARCHAR(8),
	@@NOW DATETIME,
	@@CURR_NO INT,
	@@CURR_PROCESS_ID VARCHAR(12),
	@@LOG_ID_H BIGINT
SELECT @@TODAY = CONVERT(VARCHAR(8), GETDATE(), 112);

--GET LAST PROCESS ID
SELECT @@LAST_PROCESS_ID = ISNULL(MAX(PROCESS_ID), '1') FROM TB_R_LOG_TRANSACTION_H
WHERE SUBSTRING(CAST(PROCESS_ID AS VARCHAR(12)), 1, 8) = @@TODAY;
IF @@LAST_PROCESS_ID = '1'
BEGIN
	SELECT @@CURR_NO = 1;
END
ELSE
BEGIN
	SELECT @@CURR_NO = CAST(SUBSTRING(@@LAST_PROCESS_ID,9,LEN(@@LAST_PROCESS_ID)) AS INT) + 1;
END;

--GET NEXT PROCESS ID
SELECT @@CURR_PROCESS_ID = RIGHT(REPLICATE('0', 4)+ CAST(@@CURR_NO AS VARCHAR(4)), 4);
SELECT @@PROC_ID = @@TODAY + @@CURR_PROCESS_ID;
SELECT @@PROCESS_ID = CAST(@@PROC_ID AS BIGINT);

SELECT @@PROCESS_ID

IF NOT EXISTS(SELECT 1 FROM TB_R_LOG_TRANSACTION_H WHERE PROCESS_ID_ICS=@0)
BEGIN
	INSERT INTO TB_R_LOG_TRANSACTION_H
			( PROCESS_ID ,
			  PROCESS_ID_ICS ,
			  MANIFEST_NO ,
			  CREATED_BY ,
			  CREATED_DATE 
			)
	VALUES  ( @@PROCESS_ID , -- PROCESS_ID - bigint
			  @0 , -- PROCESS_ID_ICS - int
			  '' , -- MANIFEST_NO - varchar(25)
			  @1 , -- CREATED_BY - varchar(20)
			  GETDATE() 
			)
END
	SELECT @@LOG_ID_H=LOG_ID_H FROM TB_R_LOG_TRANSACTION_H WHERE PROCESS_ID_ICS=@0
	
	INSERT INTO TB_R_LOG_TRANSACTION_D
			( LOG_ID_H ,
			  SEQ_NO ,
			  SYSTEM_SOURCE ,
			  USR_ID ,
			  MOVEMENT_TYPE ,
			  PROCESS_DT ,
			  POSTING_DT ,
			  MANIFEST_NO ,
			  KANBAN_ORER_NO ,
			  PROD_PURPOSE_CD ,
			  SOURCE_TYPE ,
			  PACK_MONTH,
			  D_ID,
			  VERS,
			  PART_NO ,
			  SUPP_CD ,
			  DOCK_CD ,
			  PLANT_CD ,
			  SLOC_CD ,
			  LOCATION ,
			  ERR_MESSAGE ,
			  CREATED_BY ,
			  CREATED_DT 
			)
	VALUES  ( @@LOG_ID_H , -- LOG_ID_H - bigint
			  @2 , -- SEQ_NO - numeric
			  '' , -- SYSTEM_SOURCE - varchar(20)
			  '' , -- USR_ID - varchar(20)
			  '' , -- MOVEMENT_TYPE - varchar(4)
			  GETDATE() , -- PROCESS_DT - datetime
			  GETDATE() , -- POSTING_DT - datetime
			  '' , -- MANIFEST_NO - varchar(16)
			  '' , -- KANBAN_ORER_NO - varchar(16)
			  '' , -- PROD_PURPOSE_CD - varchar(5)
			  '' , -- SOURCE_TYPE - varchar(1)

			  @9,  -- PACK_MONTH
			  @10, -- D_ID
			  @11, -- VERS

			  @3 , -- PART_NO - varchar(12)
			  @4 , -- SUPP_CD - varchar(5)
			  @5 , -- DOCK_CD - varchar(6)
			  @6 , -- PLANT_CD - varchar(4)
			  @7 , -- SLOC_CD - varchar(6)
			  '' , -- LOCATION - varchar(100)
			  @8 , -- ERR_MESSAGE - text
			  @1 , -- CREATED_BY - varchar(20)
			  GETDATE() 
			)
--SELECT * FROM TB_R_LOG_TRANSACTION_H
--SELECT * FROM TB_R_LOG_TRANSACTION_D